<div class="table-card-container" fxLayout="column">
  <mat-card fxFlex="nogrow">
    <mat-progress-bar
      [loading$]="tableDataSourceDirective.loading$"
      rxapCardProgressBar
    ></mat-progress-bar
    >
    <rxap-table-column-menu #rxapTableColumns="rxapTableColumns" matCard
    >
      <rxap-table-column-option hidden inactive name="removedAt">
        <ng-container i18n>RemovedAt</ng-container>
      </rxap-table-column-option>
      <rxap-table-column-option hidden name="actions">
        <ng-container i18n>Actions</ng-container>
      </rxap-table-column-option>
      <rxap-table-column-option hidden inactive name="_id">
        <ng-container i18n>_id</ng-container>
      </rxap-table-column-option>
      <rxap-table-column-option name="username">
        <ng-container i18n>Username</ng-container>
      </rxap-table-column-option>
      <rxap-table-column-option name="role">
        <ng-container i18n>Role</ng-container>
      </rxap-table-column-option>
    </rxap-table-column-menu>
    <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="12px">
      <button
        [rxapTableCreate]="tableDataSourceDirective"
        color="primary"
        mat-mini-fab
        style="z-index: 2"
      >
        <mat-icon>add</mat-icon>
      </button>
      <span>Create User</span>
    </div>

    <mat-card-content>
      <table
        #tableDataSourceDirective="rxapTableDataSource"
        [paginator]="paginator"
        [parameters]="parameters"
        id="user"
        mat-table
        rxapTableDataSource
      >
        <!-- region columns -->
        <ng-container matColumnDef="actions" sticky>
          <th *matHeaderCellDef mat-header-cell>
            <div fxLayout="row"></div>
          </th>
          <td *matCellDef="let element" mat-cell>
            <div fxLayout="row">
              <button
                [element]="element"
                [refresh]="true"
                i18n-matTooltip
                mat-icon-button
                matTooltip="Edit user"
                rxapTableRowAction="edit"
              >
                <mat-icon>edit</mat-icon>
                <mat-progress-bar
                  *rxapTableRowActionExecuting
                  mode="indeterminate"
                ></mat-progress-bar>
              </button>

              <button
                [element]="element"
                [refresh]="true"
                color="warn"
                i18n-matTooltip
                mat-icon-button
                matTooltip="Delete user"
                rxapConfirm
                rxapTableRowAction="delete"
              >
                <mat-icon>delete</mat-icon>
                <mat-progress-bar
                  *rxapTableRowActionExecuting
                  mode="indeterminate"
                ></mat-progress-bar>
              </button>
            </div>
          </td
          >
        </ng-container>
        <ng-container matColumnDef="_id">
          <th *matHeaderCellDef mat-header-cell>
            <ng-container i18n>_id</ng-container>
          </th>

          <td *matCellDef="let element" mat-cell>{{ element?._id }}</td>
        </ng-container>
        <ng-container matColumnDef="username">
          <th *matHeaderCellDef mat-header-cell>
            <ng-container i18n>Username</ng-container>
          </th>

          <td *matCellDef="let element" mat-cell>{{ element?.username }}</td>
        </ng-container>
        <ng-container matColumnDef="role">
          <th *matHeaderCellDef mat-header-cell>
            <ng-container i18n>Role</ng-container>
          </th>

          <td *matCellDef="let element" mat-cell>{{ element?.role }}</td>
        </ng-container>
        <!-- endregion -->
        <tr
          *matHeaderRowDef="rxapTableColumns.displayColumns"
          mat-header-row
        ></tr>

        <tr
          *matRowDef="let element; columns: rxapTableColumns.displayColumns"
          [@rowsAnimation]
          mat-row
        ></tr>
      </table>
    </mat-card-content>

    <mat-card-footer
    >
      <mat-paginator
        #paginator="matPaginator"
        [pageSizeOptions]="[5, 10, 25, 50, 75, 100, 150, 200]"
        [pageSize]="10"
        rxapPersistent
      ></mat-paginator
      >
    </mat-card-footer>
  </mat-card>
</div>
